﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.28
@EndOfDesignText@
Sub Class_Globals
	Private Const Duration As Int = 1000
	Private Meteor As View
	Private Star As List
	Private Tim As Timer
	Private const Distance as int = 40dip
	
	Dim GD As GradientDrawable
	Private Rec As Rect
	Private P As Path
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(V As View)
	Dim X,Y As Int
	Dim Tm As Long
	Meteor=V
	
	Tim.Initialize("Timer",Duration)
	Tim.Enabled=True
	
	Star.Initialize
	For i=0 To Rnd(5,8)
		Tm=DateTime.Now+600
		x=Rnd(Meteor.Width/10,Meteor.Width)
		y=Rnd(Meteor.Height/10,3*Meteor.Height/10)
		Do While DistanceStart(X,Y)=False And (DateTime.Now<Tm) Then 
			x=Rnd(Meteor.Width/10,Meteor.Width)
			y=Rnd(Meteor.Height/10,3*Meteor.Height/10)
		Loop
		Star.Add(x)
		Star.Add(Y)
	Next
	
	GD.Initialize("TOP_BOTTOM",Array As Int(Colors.Black,Colors.RGB(0,0,150)))
	Rec.Initialize(0,0,Meteor.Width,Meteor.Height)
	P.Initialize(0,Meteor.Height)
	
	P.LineTo(Meteor.Width/2-50dip,Meteor.Height-50ddip)
	P.LineTo(Meteor.Width/2+50dip,Meteor.Height)
	P.LineTo(150dip+Meteor.Width/2,Meteor.Height-20dip)
	P.LineTo(Meteor.Width,Meteor.Height)
End Sub

private Sub DistanceStart(x As Int, y As Int) As Boolean
	Dim B As Boolean = True
	
	For i=0 To (Star.Size/2)-1
		If Sqrt(Power((Star.Get(i*2)-x),2)+Power(Star.get(i*2+1)-y,2)) <Distance Then B=False
	Next
	Return b
End Sub

Sub Timer_Tick
	Dim Canv As Canvas
	
	Canv.Initialize(Meteor)
	Canv.AntiAlias=True
	
	Dim X As Int = Rnd(Meteor.Width-10dip,Meteor.Width)
	Dim Y As Int = Rnd(0,Meteor.Height/5)
	Dim Xd As Int = -Meteor.Width/10
	Dim Yd As Int = (Rnd(3*Meteor.Height/5,Meteor.height)-y)/10
	
	For Move=1 To 10
		Canv.DrawDrawable(GD,Rec)
		Canv.DrawCircle(Meteor.Width-70dip,50dip,20dip,Colors.Yellow,True,1dip)
		Canv.DrawCircle(Meteor.Width-80dip,42dip,16dip,Colors.Black,True,1dip)
		
		For i=0 To (Star.Size/2)-1
			Canv.DrawCircle(Star.Get(i*2),Star.Get(i*2+1),Rnd(1dip,3dip),Colors.White,True,1dip)
		Next
		
		Canv.DrawLine(X+Xd*(Move-1),Y+Yd*(Move-1),X+Xd*Move,Y+Yd*Move,Colors.ARGB(200,200,200,100),1dip)
		Canv.DrawPath(P,Colors.Black,True,1dip)
		Meteor.Invalidate
		Sleep(Duration/10)
	Next
End Sub